﻿using System;
using System.Net;
using FlexibleGameServer;
using FlexibleGameServer.ObjectsNetworkingModel;
using FlexibleGameServer.Sockets;

namespace ConsoleApplication2
{
    class Program
    {
        static void Main(string[] args)
        {
            var server = new StandaloneServer(new ListenerSettings(new IPEndPoint(IPAddress.Parse("127.0.0.1"), 7899)));
            server.InstantiateOnClientRegistered.Add((client) => new Point1(client));
            server.OnClientRegistered += client =>
            {
                client.OnPointRegistered +=
                    point =>
                    {
                        for (int i = server.Clients.ClientList.Count - 1; i >= 0; i--)
                        {
                            var cl = server.Clients.ClientList[i];
                            try
                            {
                                cl.AddVisiblePoint(point);
                            }
                            catch (Exception e)
                            {
                                Utils.TraceException(e);
                            }
                        }
                    };


                for (int i = server.Clients.ClientList.Count - 1; i >= 0; i--)
                {
                    var cl = server.Clients.ClientList[i];
                    for (int j = cl.MyObjects.Count - 1; j >= 0; j--)
                    {
                        try
                        {
                            client.AddVisiblePoint(cl.MyObjects[j]);
                        }
                        catch (Exception e)
                        {
                            Utils.TraceException(e);
                        }
                    }
                }

            };
            Console.WriteLine("Running");
            FGSEngineTesting.Test();
            Console.ReadLine();
            server.Dispose();
        }
    }
}
